<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://www.mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_BannerSlider
 * @copyright   Copyright (c) Mageplaza (https://www.mageplaza.com/)
 * @license     https://www.mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\BannerSlider\Controller\Adminhtml\Banner;

use Mageplaza\BannerSlider\Controller\Adminhtml\Banner;

/**
 * Class Delete
 * @package Mageplaza\BannerSlider\Controller\Adminhtml\Banner
 */
class Delete extends Banner
{
    /**
     * execute action
     *
     * @return \Magento\Backend\Model\View\Result\Redirect
     */
    public function execute()
    {
        $resultRedirect = $this->resultRedirectFactory->create();
        try {
            /** @var \Mageplaza\BannerSlider\Model\Banner $banner */
            $banner = $this->bannerFactory->create()
                                          ->load($this->getRequest()->getParam('banner_id'))
                                          ->delete();
            $this->messageManager->addSuccess(__('The Banner has been deleted.'));
        } catch (\Exception $e) {
            // display error message
            $this->messageManager->addErrorMessage($e->getMessage());
            // go back to edit form
            $resultRedirect->setPath('mpbannerslider/*/edit', ['banner_id' => $this->getRequest()->getParam('banner_id')]);

            return $resultRedirect;
        }

        $resultRedirect->setPath('mpbannerslider/*/');

        return $resultRedirect;
    }
}
